import React, { useState, useRef } from 'react'
import { Button, Flex, Space, Modal, Dropdown, message } from 'antd'
import NewVendor from './Vendors/NewVendor'
import ObjectTable from '../common/ObjectTable'
import PlusIcon from '../../Icons/PlusIcon'
import ReloadIcon from '../../Icons/ReloadIcon'
import useColumnVisibility from '../hooks/useColumnVisibility'
import GridIcon from '../../Icons/GridIcon'
import ListIcon from '../../Icons/ListIcon'
import useViewMode from '../hooks/useViewMode'
import ColumnViewButton from '../common/ColumnViewButton'

const Vendors = () => {
  const [messageApi, contextHolder] = message.useMessage()
  const [newVendorOpen, setNewVendorOpen] = useState(false)
  const tableRef = useRef()

  const [viewMode, setViewMode] = useViewMode('vendor')

  const [columnVisibility, setColumnVisibility] = useColumnVisibility('vendor')

  const actionItems = {
    items: [
      {
        label: 'New Vendor',
        key: 'newVendor',
        icon: <PlusIcon />
      },
      { type: 'divider' },
      {
        label: 'Reload List',
        key: 'reloadList',
        icon: <ReloadIcon />
      }
    ],
    onClick: ({ key }) => {
      if (key === 'reloadList') {
        tableRef.current?.reload()
      } else if (key === 'newVendor') {
        setNewVendorOpen(true)
      }
    }
  }

  return (
    <>
      <Flex vertical={'true'} gap='large'>
        {contextHolder}
        <Flex justify={'space-between'}>
          <Space size='small'>
            <Dropdown menu={actionItems}>
              <Button>Actions</Button>
            </Dropdown>
            <ColumnViewButton
              type='vendor'
              loading={false}
              collapseState={columnVisibility}
              updateCollapseState={setColumnVisibility}
            />
          </Space>
          <Space>
            <Button
              icon={viewMode === 'cards' ? <ListIcon /> : <GridIcon />}
              onClick={() =>
                setViewMode(viewMode === 'cards' ? 'list' : 'cards')
              }
            />
          </Space>
        </Flex>
        <ObjectTable
          ref={tableRef}
          visibleColumns={columnVisibility}
          type='vendor'
          cards={viewMode === 'cards'}
        />
      </Flex>
      <Modal
        open={newVendorOpen}
        onCancel={() => setNewVendorOpen(false)}
        footer={null}
        destroyOnHidden={true}
        width={700}
      >
        <NewVendor
          onOk={() => {
            setNewVendorOpen(false)
            messageApi.success('New vendor created successfully.')
            tableRef.current?.reload()
          }}
          reset={!newVendorOpen}
        />
      </Modal>
    </>
  )
}

export default Vendors
